import { PropType, ComputedRef } from 'vue';
import { ResizeBounding } from '../shared/typings.js';
import { PaneDirections, PaneDirectionKey, PaneEmittedData } from './ResizeBoundingPane.vue';

export declare enum Emits {
    FOCUS = "focus",
    UPDATE_WIDTH = "update:width",
    UPDATE_HEIGHT = "update:height",
    DRAG_START = "drag:start",
    DRAG_MOVE = "drag:move",
    DRAG_END = "drag:end"
}
export declare const defaultOptions: ResizeBounding.Options;
declare const _default: import('vue').DefineComponent<{
    width: NumberConstructor;
    height: NumberConstructor;
    minWidth: {
        type: NumberConstructor;
        default: number;
    };
    maxWidth: {
        type: NumberConstructor;
        default: any;
    };
    minHeight: {
        type: NumberConstructor;
        default: number;
    };
    maxHeight: {
        type: NumberConstructor;
        default: any;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    directions: {
        type: PropType<PaneDirectionKey | string>;
        default: string;
    };
    alwaysShowKnob: {
        type: BooleanConstructor;
        default: boolean;
    };
    options: {
        type: PropType<Partial<ResizeBounding.Options>>;
        default: {};
    };
    styles: {
        type: PropType<Partial<ResizeBounding.IStyles>>;
        default: {};
    };
}, {
    refRoot: import('vue').Ref<HTMLDivElement>;
    onDragStart: ({ x, y, dir }: PaneEmittedData) => void;
    onDragMove: ({ x, y, dir }: PaneEmittedData) => void;
    onDragEnd: ({ dir }: PaneEmittedData) => void;
    truncateInRange: (min: number, max: number | undefined, next: number) => number;
    computedStyle: ComputedRef<import('vue').StyleValue>;
    classNames: ResizeBounding.IResizeBoundingClassNames;
    options: ComputedRef<{
        prefix: string;
        width: number;
        activeAreaWidth: number;
        position: ResizeBounding.PanePosition;
        cursor: Partial<Record<"horizontal" | "vertical", CSSStyleDeclaration["cursor"]>>;
        knob: Partial<ResizeBounding.Knob>;
        addStateClasses: boolean;
        touchActions: boolean;
    }>;
    panes: ComputedRef<{
        left: {
            show: boolean;
            direction: PaneDirections;
        };
        right: {
            show: boolean;
            direction: PaneDirections;
        };
        bottom: {
            show: boolean;
            direction: PaneDirections;
        };
        top: {
            show: boolean;
            direction: PaneDirections;
        };
    }>;
    PaneDirections: typeof PaneDirections;
    Emits: typeof Emits;
}, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    focus: (data: {
        state: boolean;
        direction: string;
    }) => boolean;
    "update:width": (width: number) => boolean;
    "update:height": (height: number) => boolean;
    "drag:start": (dir: string) => boolean;
    "drag:move": (dir: string) => boolean;
    "drag:end": (dir: string) => boolean;
}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<{
    width: NumberConstructor;
    height: NumberConstructor;
    minWidth: {
        type: NumberConstructor;
        default: number;
    };
    maxWidth: {
        type: NumberConstructor;
        default: any;
    };
    minHeight: {
        type: NumberConstructor;
        default: number;
    };
    maxHeight: {
        type: NumberConstructor;
        default: any;
    };
    disabled: {
        type: BooleanConstructor;
        default: boolean;
    };
    directions: {
        type: PropType<PaneDirectionKey | string>;
        default: string;
    };
    alwaysShowKnob: {
        type: BooleanConstructor;
        default: boolean;
    };
    options: {
        type: PropType<Partial<ResizeBounding.Options>>;
        default: {};
    };
    styles: {
        type: PropType<Partial<ResizeBounding.IStyles>>;
        default: {};
    };
}>> & {
    onFocus?: (data: {
        state: boolean;
        direction: string;
    }) => any;
    "onDrag:start"?: (dir: string) => any;
    "onDrag:move"?: (dir: string) => any;
    "onDrag:end"?: (dir: string) => any;
    "onUpdate:width"?: (width: number) => any;
    "onUpdate:height"?: (height: number) => any;
}, {
    options: {};
    styles: {};
    minWidth: number;
    maxWidth: number;
    minHeight: number;
    maxHeight: number;
    disabled: boolean;
    directions: string;
    alwaysShowKnob: boolean;
}, {}>;
export default _default;
