import { Ref, HTMLAttributes } from 'vue';
import { ResizeBounding } from '../shared/typings.js';

export interface Props {
    prefix: string;
    direction: PaneDirectionKey;
    options: ResizeBounding.Options;
    classNames: ResizeBounding.IResizeBoundingClassNames;
    styles?: Partial<ResizeBounding.IStyles>;
}
export declare enum PaneDirectionAliases {
    HORIZONTAL = "h",
    VERTICAL = "v"
}
export declare enum PaneDirections {
    LEFT = "l",
    RIGHT = "r",
    BOTTOM = "b",
    TOP = "t"
}
export type PaneDirectionKey = PaneDirections | PaneDirections | string;
export declare enum Emits {
    FOCUS = "focus",
    DRAG_START = "drag:start",
    DRAG_MOVE = "drag:move",
    DRAG_END = "drag:end"
}
export interface PaneEmittedData {
    x: number;
    y: number;
    dir: string;
}
export declare const paneBaseStyles: (size: number, areaWidth: number, position: ResizeBounding.PanePosition) => Record<PaneDirections, HTMLAttributes["style"]>;
export declare const splitterBaseStyles: (size: number, areaWidth: number) => Record<PaneDirections, HTMLAttributes["style"]>;
declare const _default: __VLS_WithTemplateSlots<import('vue').DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    direction: PaneDirections;
}>, {
    refPane: Ref<HTMLDivElement>;
}, unknown, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    "drag:start": (data: PaneEmittedData) => void;
    "drag:move": (data: PaneEmittedData) => void;
    "drag:end": (data: PaneEmittedData) => void;
    focus: (isFocused: boolean) => void;
}, string, import('vue').PublicProps, Readonly<import('vue').ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<Props>, {
    direction: PaneDirections;
}>>> & {
    onFocus?: (isFocused: boolean) => any;
    "onDrag:start"?: (data: PaneEmittedData) => any;
    "onDrag:move"?: (data: PaneEmittedData) => any;
    "onDrag:end"?: (data: PaneEmittedData) => any;
}, {
    direction: PaneDirectionKey;
}, {}>, {
    default?(_: {}): any;
}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? __VLS_Prettify<P[K] & {
        default: D[K];
    }> : P[K];
};
type __VLS_Prettify<T> = {
    [K in keyof T]: T[K];
} & {};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
