import { default as fluentui } from '@fluentui/merge-styles';

export declare namespace ResizeBounding {
    interface Knob {
        show: boolean;
        normalHidden: boolean;
    }
    enum SplitterPositions {
        CENTER = "central",
        EXTERNAL = "external",
        INTERNAL = "internal"
    }
    type PanePosition = SplitterPositions | string;
    interface Options {
        prefix: string;
        width: number;
        activeAreaWidth?: number;
        position: PanePosition;
        cursor: Partial<Record<"horizontal" | "vertical", CSSStyleDeclaration["cursor"]>>;
        knob: Partial<Knob>;
        addStateClasses: boolean;
        touchActions: boolean;
    }
    type ResizeBoundingClassNames = "container" | "pane" | "splitter" | "splitterContainer" | "knob";
    interface IResizeBoundingClassNames {
        container: string;
        pane: string;
        splitter: string;
        splitterContainer: string;
        knob: string;
    }
    interface IStyles extends Record<ResizeBoundingClassNames, IStyle> {
    }
    type IStyle = fluentui.IStyle;
    type IStyleSet = fluentui.IStyleSet;
}
