import { defineComponent, ref, computed, onMounted, onUnmounted, openBlock, createElementBlock, normalizeClass, normalizeStyle, createElementVNode, renderSlot, createCommentVNode, resolveComponent, mergeProps, Fragment, renderList, createBlock, withCtx } from "vue";
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
var isMergeableObject = function isMergeableObject2(value) {
  return isNonNullObject(value) && !isSpecial(value);
};
function isNonNullObject(value) {
  return !!value && typeof value === "object";
}
function isSpecial(value) {
  var stringValue = Object.prototype.toString.call(value);
  return stringValue === "[object RegExp]" || stringValue === "[object Date]" || isReactElement(value);
}
var canUseSymbol = typeof Symbol === "function" && Symbol.for;
var REACT_ELEMENT_TYPE = canUseSymbol ? Symbol.for("react.element") : 60103;
function isReactElement(value) {
  return value.$$typeof === REACT_ELEMENT_TYPE;
}
function emptyTarget(val) {
  return Array.isArray(val) ? [] : {};
}
function cloneUnlessOtherwiseSpecified(value, options) {
  return options.clone !== false && options.isMergeableObject(value) ? deepmerge(emptyTarget(value), value, options) : value;
}
function defaultArrayMerge(target, source, options) {
  return target.concat(source).map(function(element) {
    return cloneUnlessOtherwiseSpecified(element, options);
  });
}
function getMergeFunction(key, options) {
  if (!options.customMerge) {
    return deepmerge;
  }
  var customMerge = options.customMerge(key);
  return typeof customMerge === "function" ? customMerge : deepmerge;
}
function getEnumerableOwnPropertySymbols(target) {
  return Object.getOwnPropertySymbols ? Object.getOwnPropertySymbols(target).filter(function(symbol) {
    return Object.propertyIsEnumerable.call(target, symbol);
  }) : [];
}
function getKeys(target) {
  return Object.keys(target).concat(getEnumerableOwnPropertySymbols(target));
}
function propertyIsOnObject(object, property) {
  try {
    return property in object;
  } catch (_) {
    return false;
  }
}
function propertyIsUnsafe(target, key) {
  return propertyIsOnObject(target, key) && !(Object.hasOwnProperty.call(target, key) && Object.propertyIsEnumerable.call(target, key));
}
function mergeObject(target, source, options) {
  var destination = {};
  if (options.isMergeableObject(target)) {
    getKeys(target).forEach(function(key) {
      destination[key] = cloneUnlessOtherwiseSpecified(target[key], options);
    });
  }
  getKeys(source).forEach(function(key) {
    if (propertyIsUnsafe(target, key)) {
      return;
    }
    if (propertyIsOnObject(target, key) && options.isMergeableObject(source[key])) {
      destination[key] = getMergeFunction(key, options)(target[key], source[key], options);
    } else {
      destination[key] = cloneUnlessOtherwiseSpecified(source[key], options);
    }
  });
  return destination;
}
function deepmerge(target, source, options) {
  options = options || {};
  options.arrayMerge = options.arrayMerge || defaultArrayMerge;
  options.isMergeableObject = options.isMergeableObject || isMergeableObject;
  options.cloneUnlessOtherwiseSpecified = cloneUnlessOtherwiseSpecified;
  var sourceIsArray = Array.isArray(source);
  var targetIsArray = Array.isArray(target);
  var sourceAndTargetTypesMatch = sourceIsArray === targetIsArray;
  if (!sourceAndTargetTypesMatch) {
    return cloneUnlessOtherwiseSpecified(source, options);
  } else if (sourceIsArray) {
    return options.arrayMerge(target, source, options);
  } else {
    return mergeObject(target, source, options);
  }
}
deepmerge.all = function deepmergeAll(array, options) {
  if (!Array.isArray(array)) {
    throw new Error("first argument should be an array");
  }
  return array.reduce(function(prev, next) {
    return deepmerge(prev, next, options);
  }, {});
};
var deepmerge_1 = deepmerge;
var cjs = deepmerge_1;
const deepmerge$1 = /* @__PURE__ */ getDefaultExportFromCjs(cjs);
var ResizeBounding$1;
((ResizeBounding2) => {
  ((SplitterPositions2) => {
    SplitterPositions2["CENTER"] = "central";
    SplitterPositions2["EXTERNAL"] = "external";
    SplitterPositions2["INTERNAL"] = "internal";
  })(ResizeBounding2.SplitterPositions || (ResizeBounding2.SplitterPositions = {}));
})(ResizeBounding$1 || (ResizeBounding$1 = {}));
var PaneDirectionAliases = /* @__PURE__ */ ((PaneDirectionAliases2) => {
  PaneDirectionAliases2["HORIZONTAL"] = "h";
  PaneDirectionAliases2["VERTICAL"] = "v";
  return PaneDirectionAliases2;
})(PaneDirectionAliases || {});
var PaneDirections = /* @__PURE__ */ ((PaneDirections2) => {
  PaneDirections2["LEFT"] = "l";
  PaneDirections2["RIGHT"] = "r";
  PaneDirections2["BOTTOM"] = "b";
  PaneDirections2["TOP"] = "t";
  return PaneDirections2;
})(PaneDirections || {});
const paneBaseStyles = (size, areaWidth, position) => {
  let _offset = "0px";
  switch (position) {
    case ResizeBounding$1.SplitterPositions.CENTER:
      _offset = `-${areaWidth / 2}px`;
      break;
    case ResizeBounding$1.SplitterPositions.EXTERNAL:
      _offset = `-${(areaWidth + size) / 2}px`;
      break;
    case ResizeBounding$1.SplitterPositions.INTERNAL:
      _offset = `-${(areaWidth - size) / 2}px`;
      break;
  }
  return {
    l: { top: "0px", left: _offset, width: `${areaWidth}px`, height: "100%" },
    r: { top: "0px", right: _offset, width: `${areaWidth}px`, height: "100%" },
    t: { left: "0px", top: _offset, width: "100%", height: `${areaWidth}px` },
    b: {
      left: "0px",
      bottom: _offset,
      width: "100%",
      height: `${areaWidth}px`
    }
  };
};
const splitterBaseStyles = (size, areaWidth) => {
  const _size = `${size}px`;
  const _offset = `${(areaWidth - size) / 2}px`;
  return {
    l: { right: _offset, width: _size, height: "100%" },
    r: { left: _offset, width: _size, height: "100%" },
    t: { bottom: _offset, height: _size, width: "100%" },
    b: { top: _offset, height: _size, width: "100%" }
  };
};
const _sfc_main$1 = /* @__PURE__ */ defineComponent({
  __name: "ResizeBoundingPane",
  props: {
    prefix: {},
    direction: {
      default: "r"
      /* RIGHT */
    },
    options: {},
    classNames: {},
    styles: {}
  },
  setup(__props, { expose: __expose, emit: __emit }) {
    const props = __props;
    const emits = __emit;
    const refPane = ref(null);
    const paneComputedStyle = computed(() => {
      var _a2, _b;
      const _width = ((_a2 = props.options) == null ? void 0 : _a2.width) ?? 1;
      if (refPane.value && _width) {
        const _areaWidth = props.options.activeAreaWidth ?? props.options.width;
        const _styles = paneBaseStyles(
          _width,
          _areaWidth,
          ((_b = props.options) == null ? void 0 : _b.position) ?? ResizeBounding$1.SplitterPositions.CENTER
        );
        const value = _styles[props.direction];
        return value;
      }
      return;
    });
    const splitterComputedStyle = computed(() => {
      var _a2;
      const _width = (_a2 = props.options) == null ? void 0 : _a2.width;
      if (refPane.value && _width) {
        const _areaWidth = props.options.activeAreaWidth ?? props.options.width;
        const _styles = splitterBaseStyles(_width, _areaWidth);
        const value = _styles[props.direction];
        return value;
      }
    });
    const isFocused = ref(false);
    const isPressed = ref(false);
    let isResizing = false;
    const knobComputedStyle = computed(() => {
      const isHorizontal = checkIsHorizontal();
      return { transform: `rotate(${isHorizontal ? 90 : 0}deg)` };
    });
    const checkIsHorizontal = () => new RegExp(
      `[${"l"} | ${"r"} | ${"h"}]`
    ).test(props.direction);
    const checkIsVertical = () => new RegExp(
      `[${"t"} | ${"b"} | ${"v"}]`
    ).test(props.direction);
    const updateCursor = (state) => {
      var _a2, _b, _c, _d;
      let cursorActive;
      if (checkIsHorizontal()) {
        cursorActive = ((_b = (_a2 = props.options) == null ? void 0 : _a2.cursor) == null ? void 0 : _b.horizontal) ?? "auto";
      } else if (checkIsVertical()) {
        cursorActive = ((_d = (_c = props.options) == null ? void 0 : _c.cursor) == null ? void 0 : _d.vertical) ?? "auto";
      } else cursorActive = "auto";
      if (refPane.value) refPane.value.style.cursor = state ? cursorActive : "auto";
    };
    const emitFocus = (state) => {
      emits("focus", state);
    };
    const onFocus = (e, isFocused2) => {
      e.stopPropagation();
      onSelected(isFocused2);
    };
    const onSelected = (state) => {
      isFocused.value = state;
      updateCursor(state);
      emitFocus(state);
    };
    const onDragStart = (e) => {
      e.preventDefault();
      e.stopImmediatePropagation();
      if (!props.options.touchActions && e.pointerType === "touch") return;
      isResizing = true;
      isPressed.value = true;
      onSelected(isResizing);
      const el = e.currentTarget;
      el.setPointerCapture(e.pointerId);
      emits("drag:start", {
        x: Math.round(e.clientX),
        y: Math.round(e.clientY),
        dir: props.direction
      });
      const onDragMove = (e2) => {
        emits("drag:move", {
          x: Math.round(e2.clientX),
          y: Math.round(e2.clientY),
          dir: props.direction
        });
      };
      const onDragEnd = (e2) => {
        isResizing = false;
        isPressed.value = false;
        updateCursor(isResizing);
        const el2 = e2.currentTarget;
        el2.releasePointerCapture(e2.pointerId);
        el2.removeEventListener("pointermove", onDragMove);
        el2.removeEventListener("pointerup", onDragEnd);
        emits("drag:end", {
          x: Math.round(e2.clientX),
          y: Math.round(e2.clientY),
          dir: props.direction
        });
      };
      el.addEventListener("pointermove", onDragMove);
      el.addEventListener("pointerup", onDragEnd);
    };
    const onDragCancel = (e) => {
      const el = e.currentTarget;
      isResizing = false;
      el.releasePointerCapture(e.pointerId);
      emits("drag:end", {
        x: Math.round(e.clientX),
        y: Math.round(e.clientY),
        dir: props.direction
      });
    };
    const addEventListeners = () => {
      const el = refPane.value;
      if (el) {
        el.addEventListener("pointerenter", (e) => onFocus(e, true));
        el.addEventListener("pointerleave", (e) => onFocus(e, false));
        el.addEventListener("pointerdown", onDragStart);
        el.addEventListener("pointercancel", onDragCancel);
      }
    };
    const removeEventListeners = () => {
      const el = refPane.value;
      if (el) {
        el.removeEventListener("pointerenter", (e) => onFocus(e, true));
        el.removeEventListener("pointerleave", (e) => onFocus(e, false));
        el.removeEventListener("pointerdown", onDragStart);
        el.addEventListener("pointercancel", onDragCancel);
      }
    };
    onMounted(addEventListeners);
    onUnmounted(removeEventListeners);
    __expose({ refPane });
    return (_ctx, _cache) => {
      var _a2, _b, _c, _d;
      return openBlock(), createElementBlock("div", {
        ref_key: "refPane",
        ref: refPane,
        class: normalizeClass([
          _ctx.classNames.pane,
          `--${_ctx.direction}`,
          _ctx.options.addStateClasses && {
            normal: !isPressed.value && !isFocused.value,
            focused: isFocused.value,
            pressed: isPressed.value
          }
        ]),
        "data-testid": "resize-bounding-pane",
        style: normalizeStyle([paneComputedStyle.value])
      }, [
        createElementVNode("div", {
          "data-testid": "resize-bounding-splitter",
          class: normalizeClass([_ctx.classNames.splitter]),
          style: normalizeStyle([splitterComputedStyle.value])
        }, [
          (isFocused.value || !((_b = (_a2 = _ctx.options) == null ? void 0 : _a2.knob) == null ? void 0 : _b.normalHidden)) && ((_d = (_c = _ctx.options) == null ? void 0 : _c.knob) == null ? void 0 : _d.show) ? (openBlock(), createElementBlock("div", {
            key: 0,
            "data-testid": "resize-bounding-splitter-container",
            class: normalizeClass([_ctx.classNames.splitterContainer]),
            style: normalizeStyle([knobComputedStyle.value])
          }, [
            createElementVNode("div", {
              "data-testid": "resize-bounding-knob",
              class: normalizeClass([_ctx.classNames.knob])
            }, [
              _ctx.$slots.default ? renderSlot(_ctx.$slots, "default", { key: 0 }) : createCommentVNode("", true)
            ], 2)
          ], 6)) : createCommentVNode("", true)
        ], 6)
      ], 6);
    };
  }
});
var GLOBAL_STYLESHEET_KEY = "__global__";
var SHADOW_DOM_STYLESHEET_SETTING = "__shadow_dom_stylesheet__";
var DEFAULT_SHADOW_CONFIG = {
  stylesheetKey: GLOBAL_STYLESHEET_KEY,
  inShadow: false,
  window: void 0,
  __isShadowConfig__: true
};
var isShadowConfig = function(value) {
  if (!(value && isRecord(value))) {
    return false;
  }
  return value.__isShadowConfig__ === true;
};
function isRecord(value) {
  return value !== null && typeof value === "object" && !Array.isArray(value);
}
function extractStyleParts(sheet) {
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  var classes = [];
  var objects = [];
  var stylesheet = sheet;
  function _processArgs(argsList) {
    for (var _i2 = 0, argsList_1 = argsList; _i2 < argsList_1.length; _i2++) {
      var arg = argsList_1[_i2];
      if (arg && !isShadowConfig(arg)) {
        if (typeof arg === "string") {
          if (arg.indexOf(" ") >= 0) {
            _processArgs(arg.split(" "));
          } else {
            var translatedArgs = stylesheet.argsFromClassName(arg);
            if (translatedArgs) {
              _processArgs(translatedArgs);
            } else {
              if (classes.indexOf(arg) === -1) {
                classes.push(arg);
              }
            }
          }
        } else if (Array.isArray(arg)) {
          _processArgs(arg);
        } else if (typeof arg === "object") {
          objects.push(arg);
        }
      }
    }
  }
  _processArgs(args);
  return {
    classes,
    objects
  };
}
function getRTL() {
  if (_rtl === void 0) {
    _rtl = // eslint-disable-next-line no-restricted-globals
    typeof document !== "undefined" && // eslint-disable-next-line no-restricted-globals
    !!document.documentElement && // eslint-disable-next-line no-restricted-globals
    document.documentElement.getAttribute("dir") === "rtl";
  }
  return _rtl;
}
var _rtl;
_rtl = getRTL();
function getStyleOptions() {
  return {
    rtl: getRTL(),
    shadowConfig: DEFAULT_SHADOW_CONFIG
  };
}
var __assign = function() {
  __assign = Object.assign || function __assign2(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}
typeof SuppressedError === "function" ? SuppressedError : function(error, suppressed, message) {
  var e = new Error(message);
  return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};
var InjectionMode = {
  /**
   * Avoids style injection, use getRules() to read the styles.
   */
  none: 0,
  /**
   * Inserts rules using the insertRule api.
   */
  insertNode: 1,
  /**
   * Appends rules using appendChild.
   */
  appendChild: 2
};
var STYLESHEET_SETTING = "__stylesheet__";
var REUSE_STYLE_NODE = typeof navigator !== "undefined" && /rv:11.0/.test(navigator.userAgent);
var _global = {};
try {
  _global = window || {};
} catch (_a2) {
}
var _stylesheet;
var Stylesheet = (
  /** @class */
  function() {
    function Stylesheet2(config, serializedStylesheet) {
      var _a2, _b, _c, _d, _e, _f;
      this._rules = [];
      this._preservedRules = [];
      this._counter = 0;
      this._keyToClassName = {};
      this._onInsertRuleCallbacks = [];
      this._onResetCallbacks = [];
      this._classNameToArgs = {};
      this._config = __assign({ injectionMode: typeof document === "undefined" ? InjectionMode.none : InjectionMode.insertNode, defaultPrefix: "css", namespace: void 0, cspSettings: void 0 }, config);
      this._classNameToArgs = (_a2 = serializedStylesheet === null || serializedStylesheet === void 0 ? void 0 : serializedStylesheet.classNameToArgs) !== null && _a2 !== void 0 ? _a2 : this._classNameToArgs;
      this._counter = (_b = serializedStylesheet === null || serializedStylesheet === void 0 ? void 0 : serializedStylesheet.counter) !== null && _b !== void 0 ? _b : this._counter;
      this._keyToClassName = (_d = (_c = this._config.classNameCache) !== null && _c !== void 0 ? _c : serializedStylesheet === null || serializedStylesheet === void 0 ? void 0 : serializedStylesheet.keyToClassName) !== null && _d !== void 0 ? _d : this._keyToClassName;
      this._preservedRules = (_e = serializedStylesheet === null || serializedStylesheet === void 0 ? void 0 : serializedStylesheet.preservedRules) !== null && _e !== void 0 ? _e : this._preservedRules;
      this._rules = (_f = serializedStylesheet === null || serializedStylesheet === void 0 ? void 0 : serializedStylesheet.rules) !== null && _f !== void 0 ? _f : this._rules;
    }
    Stylesheet2.getInstance = function(shadowConfig) {
      _stylesheet = _global[STYLESHEET_SETTING];
      if (_global[SHADOW_DOM_STYLESHEET_SETTING]) {
        return _global[SHADOW_DOM_STYLESHEET_SETTING].getInstance(shadowConfig);
      }
      if (!_stylesheet || _stylesheet._lastStyleElement && _stylesheet._lastStyleElement.ownerDocument !== document) {
        var fabricConfig = (_global === null || _global === void 0 ? void 0 : _global.FabricConfig) || {};
        var stylesheet = new Stylesheet2(fabricConfig.mergeStyles, fabricConfig.serializedStylesheet);
        _stylesheet = stylesheet;
        _global[STYLESHEET_SETTING] = stylesheet;
      }
      return _stylesheet;
    };
    Stylesheet2.prototype.serialize = function() {
      return JSON.stringify({
        classNameToArgs: this._classNameToArgs,
        counter: this._counter,
        keyToClassName: this._keyToClassName,
        preservedRules: this._preservedRules,
        rules: this._rules
      });
    };
    Stylesheet2.prototype.setConfig = function(config) {
      this._config = __assign(__assign({}, this._config), config);
    };
    Stylesheet2.prototype.onReset = function(callback) {
      var _this = this;
      this._onResetCallbacks.push(callback);
      return function() {
        _this._onResetCallbacks = _this._onResetCallbacks.filter(function(cb) {
          return cb !== callback;
        });
      };
    };
    Stylesheet2.prototype.onInsertRule = function(callback) {
      var _this = this;
      this._onInsertRuleCallbacks.push(callback);
      return function() {
        _this._onInsertRuleCallbacks = _this._onInsertRuleCallbacks.filter(function(cb) {
          return cb !== callback;
        });
      };
    };
    Stylesheet2.prototype.getClassName = function(displayName) {
      var namespace = this._config.namespace;
      var prefix = displayName || this._config.defaultPrefix;
      return "".concat(namespace ? namespace + "-" : "").concat(prefix, "-").concat(this._counter++);
    };
    Stylesheet2.prototype.cacheClassName = function(className, key, args, rules2) {
      this._keyToClassName[this._getCacheKey(key)] = className;
      this._classNameToArgs[className] = {
        args,
        rules: rules2
      };
    };
    Stylesheet2.prototype.classNameFromKey = function(key) {
      return this._keyToClassName[this._getCacheKey(key)];
    };
    Stylesheet2.prototype.getClassNameCache = function() {
      return this._keyToClassName;
    };
    Stylesheet2.prototype.argsFromClassName = function(className) {
      var entry = this._classNameToArgs[className];
      return entry && entry.args;
    };
    Stylesheet2.prototype.insertedRulesFromClassName = function(className) {
      var entry = this._classNameToArgs[className];
      return entry && entry.rules;
    };
    Stylesheet2.prototype.insertRule = function(rule, preserve, stylesheetKey) {
      if (stylesheetKey === void 0) {
        stylesheetKey = GLOBAL_STYLESHEET_KEY;
      }
      var injectionMode = this._config.injectionMode;
      var element = injectionMode !== InjectionMode.none ? this._getStyleElement() : void 0;
      if (preserve) {
        this._preservedRules.push(rule);
      }
      if (element) {
        switch (injectionMode) {
          case InjectionMode.insertNode:
            this._insertRuleIntoSheet(element.sheet, rule);
            break;
          case InjectionMode.appendChild:
            element.appendChild(document.createTextNode(rule));
            break;
        }
      } else {
        this._rules.push(rule);
      }
      if (this._config.onInsertRule) {
        this._config.onInsertRule(rule);
      }
      this._onInsertRuleCallbacks.forEach(function(callback) {
        return callback({ key: stylesheetKey, sheet: element ? element.sheet : void 0, rule });
      });
    };
    Stylesheet2.prototype.getRules = function(includePreservedRules) {
      return (includePreservedRules ? this._preservedRules.join("") : "") + this._rules.join("");
    };
    Stylesheet2.prototype.reset = function() {
      this._rules = [];
      this._counter = 0;
      this._classNameToArgs = {};
      this._keyToClassName = {};
      this._onResetCallbacks.forEach(function(callback) {
        return callback();
      });
    };
    Stylesheet2.prototype.resetKeys = function() {
      this._keyToClassName = {};
    };
    Stylesheet2.prototype._createStyleElement = function() {
      var _a2;
      var doc = ((_a2 = this._config.window) === null || _a2 === void 0 ? void 0 : _a2.document) || document;
      var head = doc.head;
      var styleElement = doc.createElement("style");
      var nodeToInsertBefore = null;
      styleElement.setAttribute("data-merge-styles", "true");
      var cspSettings = this._config.cspSettings;
      if (cspSettings) {
        if (cspSettings.nonce) {
          styleElement.setAttribute("nonce", cspSettings.nonce);
        }
      }
      if (this._lastStyleElement) {
        nodeToInsertBefore = this._lastStyleElement.nextElementSibling;
      } else {
        var placeholderStyleTag = this._findPlaceholderStyleTag();
        if (placeholderStyleTag) {
          nodeToInsertBefore = placeholderStyleTag.nextElementSibling;
        } else {
          nodeToInsertBefore = head.childNodes[0];
        }
      }
      head.insertBefore(styleElement, head.contains(nodeToInsertBefore) ? nodeToInsertBefore : null);
      this._lastStyleElement = styleElement;
      return styleElement;
    };
    Stylesheet2.prototype._insertRuleIntoSheet = function(sheet, rule) {
      if (!sheet) {
        return false;
      }
      try {
        sheet.insertRule(rule, sheet.cssRules.length);
        return true;
      } catch (e) {
      }
      return false;
    };
    Stylesheet2.prototype._getCacheKey = function(key) {
      return key;
    };
    Stylesheet2.prototype._getStyleElement = function() {
      var _this = this;
      if (!this._styleElement) {
        this._styleElement = this._createStyleElement();
        if (!REUSE_STYLE_NODE) {
          var win = this._config.window || window;
          win.requestAnimationFrame(function() {
            _this._styleElement = void 0;
          });
        }
      }
      return this._styleElement;
    };
    Stylesheet2.prototype._findPlaceholderStyleTag = function() {
      var head = document.head;
      if (head) {
        return head.querySelector("style[data-merge-styles]");
      }
      return null;
    };
    return Stylesheet2;
  }()
);
var rules = {};
function kebabRules(rulePairs, index) {
  var rule = rulePairs[index];
  if (rule.charAt(0) !== "-") {
    rulePairs[index] = rules[rule] = rules[rule] || rule.replace(/([A-Z])/g, "-$1").toLowerCase();
  }
}
var _vendorSettings;
function getVendorSettings() {
  var _a2;
  if (!_vendorSettings) {
    var doc = typeof document !== "undefined" ? document : void 0;
    var nav = typeof navigator !== "undefined" ? navigator : void 0;
    var userAgent = (_a2 = nav === null || nav === void 0 ? void 0 : nav.userAgent) === null || _a2 === void 0 ? void 0 : _a2.toLowerCase();
    if (!doc) {
      _vendorSettings = {
        isWebkit: true,
        isMoz: true,
        isOpera: true,
        isMs: true
      };
    } else {
      _vendorSettings = {
        isWebkit: !!(doc && "WebkitAppearance" in doc.documentElement.style),
        isMoz: !!(userAgent && userAgent.indexOf("firefox") > -1),
        isOpera: !!(userAgent && userAgent.indexOf("opera") > -1),
        isMs: !!(nav && (/rv:11.0/i.test(nav.userAgent) || /Edge\/\d./i.test(navigator.userAgent)))
      };
    }
  }
  return _vendorSettings;
}
var autoPrefixNames = {
  "user-select": 1
};
function prefixRules(rulePairs, index) {
  var vendorSettings = getVendorSettings();
  var name = rulePairs[index];
  if (autoPrefixNames[name]) {
    var value = rulePairs[index + 1];
    if (autoPrefixNames[name]) {
      if (vendorSettings.isWebkit) {
        rulePairs.push("-webkit-" + name, value);
      }
      if (vendorSettings.isMoz) {
        rulePairs.push("-moz-" + name, value);
      }
      if (vendorSettings.isMs) {
        rulePairs.push("-ms-" + name, value);
      }
      if (vendorSettings.isOpera) {
        rulePairs.push("-o-" + name, value);
      }
    }
  }
}
var NON_PIXEL_NUMBER_PROPS = [
  "column-count",
  "font-weight",
  "flex",
  "flex-grow",
  "flex-shrink",
  "fill-opacity",
  "opacity",
  "order",
  "z-index",
  "zoom"
];
function provideUnits(rulePairs, index) {
  var name = rulePairs[index];
  var value = rulePairs[index + 1];
  if (typeof value === "number") {
    var isNonPixelProp = NON_PIXEL_NUMBER_PROPS.indexOf(name) > -1;
    var isVariableOrPrefixed = name.indexOf("--") > -1;
    var unit = isNonPixelProp || isVariableOrPrefixed ? "" : "px";
    rulePairs[index + 1] = "".concat(value).concat(unit);
  }
}
var _a;
var LEFT = "left";
var RIGHT = "right";
var NO_FLIP = "@noflip";
var NAME_REPLACEMENTS = (_a = {}, _a[LEFT] = RIGHT, _a[RIGHT] = LEFT, _a);
var VALUE_REPLACEMENTS = {
  "w-resize": "e-resize",
  "sw-resize": "se-resize",
  "nw-resize": "ne-resize"
};
function rtlifyRules(options, rulePairs, index) {
  if (options.rtl) {
    var name_1 = rulePairs[index];
    if (!name_1) {
      return;
    }
    var value = rulePairs[index + 1];
    if (typeof value === "string" && value.indexOf(NO_FLIP) >= 0) {
      rulePairs[index + 1] = value.replace(/\s*(?:\/\*\s*)?\@noflip\b(?:\s*\*\/)?\s*?/g, "");
    } else if (name_1.indexOf(LEFT) >= 0) {
      rulePairs[index] = name_1.replace(LEFT, RIGHT);
    } else if (name_1.indexOf(RIGHT) >= 0) {
      rulePairs[index] = name_1.replace(RIGHT, LEFT);
    } else if (String(value).indexOf(LEFT) >= 0) {
      rulePairs[index + 1] = value.replace(LEFT, RIGHT);
    } else if (String(value).indexOf(RIGHT) >= 0) {
      rulePairs[index + 1] = value.replace(RIGHT, LEFT);
    } else if (NAME_REPLACEMENTS[name_1]) {
      rulePairs[index] = NAME_REPLACEMENTS[name_1];
    } else if (VALUE_REPLACEMENTS[value]) {
      rulePairs[index + 1] = VALUE_REPLACEMENTS[value];
    } else {
      switch (name_1) {
        case "margin":
        case "padding":
          rulePairs[index + 1] = flipQuad(value);
          break;
        case "box-shadow":
          rulePairs[index + 1] = negateNum(value, 0);
          break;
      }
    }
  }
}
function negateNum(value, partIndex) {
  var parts = value.split(" ");
  var numberVal = parseInt(parts[partIndex], 10);
  parts[0] = parts[0].replace(String(numberVal), String(numberVal * -1));
  return parts.join(" ");
}
function flipQuad(value) {
  if (typeof value === "string") {
    var parts = value.split(" ");
    if (parts.length === 4) {
      return "".concat(parts[0], " ").concat(parts[3], " ").concat(parts[2], " ").concat(parts[1]);
    }
  }
  return value;
}
function tokenizeWithParentheses(value) {
  var parts = [];
  var partStart = 0;
  var parens = 0;
  for (var i = 0; i < value.length; i++) {
    switch (value[i]) {
      case "(":
        parens++;
        break;
      case ")":
        if (parens) {
          parens--;
        }
        break;
      case "	":
      case " ":
        if (!parens) {
          if (i > partStart) {
            parts.push(value.substring(partStart, i));
          }
          partStart = i + 1;
        }
        break;
    }
  }
  if (partStart < value.length) {
    parts.push(value.substring(partStart));
  }
  return parts;
}
var DISPLAY_NAME = "displayName";
function getDisplayName(rules2) {
  var rootStyle = rules2 && rules2["&"];
  return rootStyle ? rootStyle.displayName : void 0;
}
var globalSelectorRegExp = /\:global\((.+?)\)/g;
function expandCommaSeparatedGlobals(selectorWithGlobals) {
  if (!globalSelectorRegExp.test(selectorWithGlobals)) {
    return selectorWithGlobals;
  }
  var replacementInfo = [];
  var findGlobal = /\:global\((.+?)\)/g;
  var match = null;
  while (match = findGlobal.exec(selectorWithGlobals)) {
    if (match[1].indexOf(",") > -1) {
      replacementInfo.push([
        match.index,
        match.index + match[0].length,
        // Wrap each of the found selectors in :global()
        match[1].split(",").map(function(v) {
          return ":global(".concat(v.trim(), ")");
        }).join(", ")
      ]);
    }
  }
  return replacementInfo.reverse().reduce(function(selector, _a2) {
    var matchIndex = _a2[0], matchEndIndex = _a2[1], replacement = _a2[2];
    var prefix = selector.slice(0, matchIndex);
    var suffix = selector.slice(matchEndIndex);
    return prefix + replacement + suffix;
  }, selectorWithGlobals);
}
function isSelector(potentialSelector) {
  return potentialSelector.indexOf(":global(") >= 0 || potentialSelector.indexOf(":") === 0;
}
function expandSelector(newSelector, currentSelector) {
  if (newSelector.indexOf(":global(") >= 0) {
    return newSelector.replace(globalSelectorRegExp, "$1");
  } else if (newSelector.indexOf(":host(") === 0) {
    return newSelector;
  } else if (newSelector.indexOf(":") === 0) {
    return currentSelector + newSelector;
  } else if (newSelector.indexOf("&") < 0) {
    return currentSelector + " " + newSelector;
  }
  return newSelector;
}
function extractSelector(currentSelector, rules2, selector, value, stylesheet) {
  if (rules2 === void 0) {
    rules2 = { __order: [] };
  }
  if (selector.indexOf("@") === 0) {
    selector = selector + "{" + currentSelector;
    extractRules([value], rules2, selector, stylesheet);
  } else if (selector.indexOf(",") > -1) {
    expandCommaSeparatedGlobals(selector).split(",").map(function(s) {
      return s.trim();
    }).forEach(function(separatedSelector) {
      return extractRules([value], rules2, expandSelector(separatedSelector, currentSelector), stylesheet);
    });
  } else {
    extractRules([value], rules2, expandSelector(selector, currentSelector), stylesheet);
  }
}
function extractRules(args, rules2, currentSelector, stylesheet) {
  if (rules2 === void 0) {
    rules2 = { __order: [] };
  }
  if (currentSelector === void 0) {
    currentSelector = "&";
  }
  var currentRules = rules2[currentSelector];
  if (!currentRules) {
    currentRules = {};
    rules2[currentSelector] = currentRules;
    rules2.__order.push(currentSelector);
  }
  for (var _i = 0, args_1 = args; _i < args_1.length; _i++) {
    var arg = args_1[_i];
    if (typeof arg === "string") {
      var expandedRules = stylesheet.argsFromClassName(arg);
      if (expandedRules) {
        extractRules(expandedRules, rules2, currentSelector, stylesheet);
      }
    } else if (Array.isArray(arg)) {
      extractRules(arg, rules2, currentSelector, stylesheet);
    } else {
      for (var prop in arg) {
        if (arg.hasOwnProperty(prop)) {
          var propValue = arg[prop];
          if (prop === "selectors") {
            var selectors = arg.selectors;
            for (var newSelector in selectors) {
              if (selectors.hasOwnProperty(newSelector)) {
                extractSelector(currentSelector, rules2, newSelector, selectors[newSelector], stylesheet);
              }
            }
          } else if (typeof propValue === "object" || isSelector(prop)) {
            if (propValue !== null && propValue !== void 0) {
              extractSelector(currentSelector, rules2, prop, propValue, stylesheet);
            }
          } else {
            if (propValue !== void 0) {
              if (prop === "margin" || prop === "padding") {
                expandQuads(currentRules, prop, propValue);
              } else {
                currentRules[prop] = propValue;
              }
            }
          }
        }
      }
    }
  }
  return rules2;
}
function expandQuads(currentRules, name, value) {
  var parts = typeof value === "string" ? tokenizeWithParentheses(value) : [value];
  if (parts.length === 0) {
    parts.push(value);
  }
  if (parts[parts.length - 1] === "!important") {
    parts = parts.slice(0, -1).map(function(p) {
      return p + " !important";
    });
  }
  currentRules[name + "Top"] = parts[0];
  currentRules[name + "Right"] = parts[1] || parts[0];
  currentRules[name + "Bottom"] = parts[2] || parts[0];
  currentRules[name + "Left"] = parts[3] || parts[1] || parts[0];
}
function getKeyForRules(options, rules2) {
  var serialized = [options.rtl ? "rtl" : "ltr"];
  var hasProps = false;
  for (var _i = 0, _a2 = rules2.__order; _i < _a2.length; _i++) {
    var selector = _a2[_i];
    serialized.push(selector);
    var rulesForSelector = rules2[selector];
    for (var propName in rulesForSelector) {
      if (rulesForSelector.hasOwnProperty(propName) && rulesForSelector[propName] !== void 0) {
        hasProps = true;
        serialized.push(propName, rulesForSelector[propName]);
      }
    }
  }
  return hasProps ? serialized.join("") : void 0;
}
function repeatString(target, count) {
  if (count <= 0) {
    return "";
  }
  if (count === 1) {
    return target;
  }
  return target + repeatString(target, count - 1);
}
function serializeRuleEntries(options, ruleEntries) {
  if (!ruleEntries) {
    return "";
  }
  var allEntries = [];
  for (var entry in ruleEntries) {
    if (ruleEntries.hasOwnProperty(entry) && entry !== DISPLAY_NAME && ruleEntries[entry] !== void 0) {
      allEntries.push(entry, ruleEntries[entry]);
    }
  }
  for (var i = 0; i < allEntries.length; i += 2) {
    kebabRules(allEntries, i);
    provideUnits(allEntries, i);
    rtlifyRules(options, allEntries, i);
    prefixRules(allEntries, i);
  }
  for (var i = 1; i < allEntries.length; i += 4) {
    allEntries.splice(i, 1, ":", allEntries[i], ";");
  }
  return allEntries.join("");
}
function styleToRegistration(options) {
  var _a2;
  var args = [];
  for (var _i = 1; _i < arguments.length; _i++) {
    args[_i - 1] = arguments[_i];
  }
  var stylesheet = (_a2 = options.stylesheet) !== null && _a2 !== void 0 ? _a2 : Stylesheet.getInstance(options.shadowConfig);
  var rules2 = extractRules(args, void 0, void 0, stylesheet);
  var key = getKeyForRules(options, rules2);
  if (key) {
    var registration = {
      className: stylesheet.classNameFromKey(key),
      key,
      args
    };
    if (!registration.className) {
      registration.className = stylesheet.getClassName(getDisplayName(rules2));
      var rulesToInsert = [];
      for (var _b = 0, _c = rules2.__order; _b < _c.length; _b++) {
        var selector = _c[_b];
        rulesToInsert.push(selector, serializeRuleEntries(options, rules2[selector]));
      }
      registration.rulesToInsert = rulesToInsert;
    }
    return registration;
  }
  return void 0;
}
function applyRegistration(registration, specificityMultiplier, shadowConfig, sheet) {
  if (specificityMultiplier === void 0) {
    specificityMultiplier = 1;
  }
  var stylesheet = Stylesheet.getInstance(shadowConfig);
  var className = registration.className, key = registration.key, args = registration.args, rulesToInsert = registration.rulesToInsert;
  if (rulesToInsert) {
    for (var i = 0; i < rulesToInsert.length; i += 2) {
      var rules2 = rulesToInsert[i + 1];
      if (rules2) {
        var selector = rulesToInsert[i];
        selector = selector.replace(/&/g, repeatString(".".concat(registration.className), specificityMultiplier));
        var processedRule = "".concat(selector, "{").concat(rules2, "}").concat(selector.indexOf("@") === 0 ? "}" : "");
        stylesheet.insertRule(processedRule);
      }
    }
    stylesheet.cacheClassName(className, key, args, rulesToInsert);
  }
}
function concatStyleSets() {
  var styleSets = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    styleSets[_i] = arguments[_i];
  }
  if (styleSets && styleSets.length === 1 && styleSets[0] && !styleSets[0].subComponentStyles && !isShadowConfig(styleSets[0])) {
    return styleSets[0];
  }
  var mergedSet = {};
  var workingSubcomponentStyles = {};
  for (var _a2 = 0, styleSets_1 = styleSets; _a2 < styleSets_1.length; _a2++) {
    var currentSet = styleSets_1[_a2];
    if (currentSet && !isShadowConfig(currentSet)) {
      for (var prop in currentSet) {
        if (currentSet.hasOwnProperty(prop)) {
          if (prop === "subComponentStyles" && currentSet.subComponentStyles !== void 0) {
            var currentComponentStyles = currentSet.subComponentStyles;
            for (var subCompProp in currentComponentStyles) {
              if (currentComponentStyles.hasOwnProperty(subCompProp)) {
                if (workingSubcomponentStyles.hasOwnProperty(subCompProp)) {
                  workingSubcomponentStyles[subCompProp].push(currentComponentStyles[subCompProp]);
                } else {
                  workingSubcomponentStyles[subCompProp] = [currentComponentStyles[subCompProp]];
                }
              }
            }
            continue;
          }
          var mergedValue = mergedSet[prop];
          var currentValue = currentSet[prop];
          if (mergedValue === void 0) {
            mergedSet[prop] = currentValue;
          } else {
            mergedSet[prop] = __spreadArray(__spreadArray([], Array.isArray(mergedValue) ? mergedValue : [mergedValue], true), Array.isArray(currentValue) ? currentValue : [currentValue], true);
          }
        }
      }
    }
  }
  if (Object.keys(workingSubcomponentStyles).length > 0) {
    mergedSet.subComponentStyles = {};
    var mergedSubStyles = mergedSet.subComponentStyles;
    var _loop_1 = function(subCompProp2) {
      if (workingSubcomponentStyles.hasOwnProperty(subCompProp2)) {
        var workingSet_1 = workingSubcomponentStyles[subCompProp2];
        mergedSubStyles[subCompProp2] = function(styleProps) {
          return concatStyleSets.apply(void 0, workingSet_1.map(function(styleFunctionOrObject) {
            return typeof styleFunctionOrObject === "function" ? styleFunctionOrObject(styleProps) : styleFunctionOrObject;
          }));
        };
      }
    };
    for (var subCompProp in workingSubcomponentStyles) {
      _loop_1(subCompProp);
    }
  }
  return mergedSet;
}
function mergeStyleSets() {
  var styleSets = [];
  for (var _i = 0; _i < arguments.length; _i++) {
    styleSets[_i] = arguments[_i];
  }
  return mergeCssSets(styleSets, getStyleOptions());
}
function mergeCssSets(styleSets, options) {
  var classNameSet = { subComponentStyles: {} };
  var shadowConfig = void 0;
  var styleSet;
  if (isShadowConfig(styleSets[0])) {
    shadowConfig = styleSets[0];
    styleSet = styleSets[1];
  } else {
    styleSet = styleSets[0];
  }
  shadowConfig !== null && shadowConfig !== void 0 ? shadowConfig : shadowConfig = options === null || options === void 0 ? void 0 : options.shadowConfig;
  var opts = __assign(__assign({}, options), { shadowConfig });
  if (!styleSet && styleSets.length <= 1) {
    return { subComponentStyles: {} };
  }
  var sheet = Stylesheet.getInstance(shadowConfig);
  opts.stylesheet = sheet;
  var concatenatedStyleSet = concatStyleSets.apply(void 0, styleSets);
  var registrations = [];
  for (var styleSetArea in concatenatedStyleSet) {
    if (concatenatedStyleSet.hasOwnProperty(styleSetArea)) {
      if (styleSetArea === "subComponentStyles") {
        classNameSet.subComponentStyles = concatenatedStyleSet.subComponentStyles || {};
        continue;
      } else if (styleSetArea === "__shadowConfig__") {
        continue;
      }
      var styles = concatenatedStyleSet[styleSetArea];
      var _a2 = extractStyleParts(sheet, styles), classes = _a2.classes, objects = _a2.objects;
      if (objects === null || objects === void 0 ? void 0 : objects.length) {
        var registration = styleToRegistration(opts || {}, { displayName: styleSetArea }, objects);
        if (registration) {
          registrations.push(registration);
          classNameSet[styleSetArea] = classes.concat([registration.className]).join(" ");
        }
      } else {
        classNameSet[styleSetArea] = classes.join(" ");
      }
    }
  }
  for (var _i = 0, registrations_1 = registrations; _i < registrations_1.length; _i++) {
    var registration = registrations_1[_i];
    if (registration) {
      applyRegistration(registration, options === null || options === void 0 ? void 0 : options.specificityMultiplier, shadowConfig);
    }
  }
  return classNameSet;
}
const PREFIX = "resize-bounding-";
const globalClassNames = (prefix = PREFIX) => ({
  container: `${prefix}container`,
  pane: `${prefix}pane`,
  splitter: `${prefix}splitter`,
  splitterContainer: `${prefix}splitter--container`,
  knob: `${prefix}knob`
});
const defaultStyles = (prefix) => ({
  container: [
    globalClassNames(prefix).container,
    { displayName: globalClassNames(prefix).container, position: "relative" }
  ],
  pane: [
    globalClassNames(prefix).pane,
    {
      displayName: globalClassNames(prefix).pane,
      position: "absolute",
      display: "block",
      zIndex: 9999,
      touchAction: "none"
    }
  ],
  splitter: [
    globalClassNames(prefix).splitter,
    {
      displayName: globalClassNames(prefix).splitter,
      position: "absolute",
      zIndex: 9999,
      transition: "background 125ms ease-out",
      ":hover": {
        background: "cornflowerblue"
      }
    }
  ],
  splitterContainer: [
    globalClassNames(prefix).splitterContainer,
    {
      displayName: globalClassNames(prefix).splitterContainer,
      position: "relative",
      display: "flex",
      alignItems: "center",
      justifyContent: "center",
      top: "50%",
      left: "50%",
      width: `0px`,
      height: `0px`
    }
  ],
  knob: [
    globalClassNames(prefix).knob,
    {
      displayName: globalClassNames(prefix).knob,
      position: "absolute",
      width: "64px",
      height: "8px",
      background: "gray",
      borderRadius: "4px",
      transition: "background 125ms ease-out",
      [`.${globalClassNames(prefix).pane} :hover &`]: {
        background: "cornflowerblue"
      }
    }
  ]
});
const getClassNames = (args, prefix = PREFIX) => {
  return mergeStyleSets(defaultStyles(prefix), args);
};
var Emits = /* @__PURE__ */ ((Emits2) => {
  Emits2["FOCUS"] = "focus";
  Emits2["UPDATE_WIDTH"] = "update:width";
  Emits2["UPDATE_HEIGHT"] = "update:height";
  Emits2["DRAG_START"] = "drag:start";
  Emits2["DRAG_MOVE"] = "drag:move";
  Emits2["DRAG_END"] = "drag:end";
  return Emits2;
})(Emits || {});
const defaultOptions = {
  prefix: PREFIX,
  width: 4,
  activeAreaWidth: void 0,
  position: "central",
  knob: {
    show: false,
    normalHidden: false
  },
  cursor: {
    horizontal: "col-resize",
    vertical: "row-resize"
  },
  addStateClasses: false,
  touchActions: true
};
const _sfc_main = defineComponent({
  setup(props, { emit }) {
    const refRoot = ref(null);
    const options = computed(() => {
      return deepmerge$1(defaultOptions, props.options);
    });
    const classNames = getClassNames(
      props.styles,
      options.value.prefix ?? PREFIX
    );
    let { width: newWidth, height: newHeight } = props;
    let prevWidth = newWidth, prevHeight = newHeight;
    const computedStyle = computed(() => {
      const _width = {
        width: `${props.width}px`,
        minWidth: `${props.width}px`
      };
      const _height = {
        height: `${props.height}px`,
        minHeight: `${props.height}px`
      };
      return {
        ...props.width && _width,
        ...props.height && _height
      };
    });
    const panes = computed(() => ({
      left: {
        show: RegExp(PaneDirections.LEFT).test(props.directions) || RegExp(PaneDirectionAliases.HORIZONTAL).test(props.directions),
        direction: PaneDirections.LEFT
      },
      right: {
        show: RegExp(PaneDirections.RIGHT).test(props.directions) || RegExp(PaneDirectionAliases.HORIZONTAL).test(props.directions),
        direction: PaneDirections.RIGHT
      },
      bottom: {
        show: RegExp(PaneDirections.BOTTOM).test(props.directions) || RegExp(PaneDirectionAliases.VERTICAL).test(props.directions),
        direction: PaneDirections.BOTTOM
      },
      top: {
        show: RegExp(PaneDirections.TOP).test(props.directions) || RegExp(PaneDirectionAliases.VERTICAL).test(props.directions),
        direction: PaneDirections.TOP
      }
    }));
    let startWidth = props.width ?? 0, startHeight = props.height ?? 0;
    let startX = 0, startY = 0;
    const onDragStart = ({ x, y, dir }) => {
      startWidth = props.width ?? 0;
      startHeight = props.height ?? 0;
      startX = x;
      startY = y;
      emit("drag:start", dir);
    };
    const truncateInRange = (min, max, next) => {
      const _max = max ?? Number.POSITIVE_INFINITY;
      if (next <= min) return min;
      else if (next >= _max) return _max;
      return next;
    };
    const onDragMove = ({ x, y, dir }) => {
      if (!refRoot.value) return;
      emit("drag:move", dir);
      if (dir === PaneDirections.LEFT) {
        newWidth = startWidth + (startX - x);
        if (prevWidth === newWidth) return;
        const truncated = truncateInRange(
          props.minWidth,
          props.maxWidth,
          newWidth
        );
        emit("update:width", truncated);
        prevWidth = truncated;
      } else if (dir === PaneDirections.RIGHT) {
        newWidth = startWidth + (x - startX);
        if (prevWidth === newWidth) return;
        const truncated = truncateInRange(
          props.minWidth,
          props.maxWidth,
          newWidth
        );
        emit("update:width", truncated);
        prevWidth = truncated;
      } else if (dir === PaneDirections.TOP) {
        newHeight = startHeight + (startY - y);
        if (prevHeight === newHeight) return;
        const truncated = truncateInRange(
          props.minHeight,
          props.maxHeight,
          newHeight
        );
        emit("update:height", truncated);
        prevHeight = truncated;
      } else if (dir === PaneDirections.BOTTOM) {
        newHeight = startHeight + (y - startY);
        if (prevHeight === newHeight) return;
        const truncated = truncateInRange(
          props.minHeight,
          props.maxHeight,
          newHeight
        );
        emit("update:height", truncated);
        prevHeight = truncated;
      }
    };
    const onDragEnd = ({ dir }) => {
      emit("drag:end", dir);
    };
    return {
      refRoot,
      onDragStart,
      onDragMove,
      onDragEnd,
      truncateInRange,
      computedStyle,
      classNames,
      options,
      panes,
      PaneDirections,
      Emits
    };
  },
  inheritAttrs: true,
  emits: {
    [
      "focus"
      /* FOCUS */
    ]: (data) => typeof data === "object" && "state" in data && typeof data.state === "boolean" && "direction" in data && typeof data.direction === "string",
    [
      "update:width"
      /* UPDATE_WIDTH */
    ]: (width) => typeof width === "number",
    [
      "update:height"
      /* UPDATE_HEIGHT */
    ]: (height) => typeof height === "number",
    [
      "drag:start"
      /* DRAG_START */
    ]: (dir) => typeof dir === "string",
    [
      "drag:move"
      /* DRAG_MOVE */
    ]: (dir) => typeof dir === "string",
    [
      "drag:end"
      /* DRAG_END */
    ]: (dir) => typeof dir === "string"
  },
  props: {
    width: Number,
    height: Number,
    minWidth: {
      type: Number,
      default: 0
    },
    maxWidth: {
      type: Number,
      default: void 0
    },
    minHeight: {
      type: Number,
      default: 0
    },
    maxHeight: {
      type: Number,
      default: void 0
    },
    disabled: {
      type: Boolean,
      default: false
    },
    directions: {
      type: String,
      default: `${PaneDirectionAliases.HORIZONTAL}${PaneDirectionAliases.VERTICAL}`
    },
    alwaysShowKnob: {
      type: Boolean,
      default: false
    },
    options: {
      type: Object,
      default: {}
    },
    styles: {
      type: Object,
      default: {}
    }
  },
  name: "ResizeBounding",
  components: { ResizeBoundingPane: _sfc_main$1 }
});
const _export_sfc = (sfc, props) => {
  const target = sfc.__vccOpts || sfc;
  for (const [key, val] of props) {
    target[key] = val;
  }
  return target;
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  const _component_ResizeBoundingPane = resolveComponent("ResizeBoundingPane");
  return openBlock(), createElementBlock("div", mergeProps(_ctx.$attrs, {
    ref: "refRoot",
    "data-testid": "resize-bounding-container",
    class: [_ctx.classNames.container],
    style: [_ctx.computedStyle]
  }), [
    renderSlot(_ctx.$slots, "default"),
    (openBlock(true), createElementBlock(Fragment, null, renderList(_ctx.panes, ({ show, direction }, idx) => {
      return openBlock(), createElementBlock(Fragment, { key: idx }, [
        !_ctx.disabled && show ? (openBlock(), createBlock(_component_ResizeBoundingPane, {
          key: 0,
          prefix: _ctx.options.prefix ?? "",
          direction,
          options: _ctx.options,
          styles: _ctx.styles,
          classNames: _ctx.classNames,
          onFocus: (isFocused) => {
            _ctx.$emit(_ctx.Emits.FOCUS, { state: isFocused, direction });
          },
          "onDrag:start": _ctx.onDragStart,
          "onDrag:move": _ctx.onDragMove,
          "onDrag:end": _ctx.onDragEnd
        }, {
          default: withCtx(() => [
            renderSlot(_ctx.$slots, "knob")
          ]),
          _: 2
        }, 1032, ["prefix", "direction", "options", "styles", "classNames", "onFocus", "onDrag:start", "onDrag:move", "onDrag:end"])) : createCommentVNode("", true)
      ], 64);
    }), 128))
  ], 16);
}
const ResizeBounding = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  PREFIX,
  ResizeBounding$1 as ResizeBounding,
  ResizeBounding as default,
  globalClassNames
};
